'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// this should be the entry point to your library

var SelectionPopover = function (_Component) {
  _inherits(SelectionPopover, _Component);

  function SelectionPopover(props) {
    _classCallCheck(this, SelectionPopover);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(SelectionPopover).call(this, props));

    _this._handleMouseUp = function () {
      var selection = document.getSelection();
      if (selection.toString().length) {
        var selectionBox = selection.getRangeAt(0).getBoundingClientRect();
        _this.setState({
          selectionBox: selectionBox,
          popoverWidth: _this.refs.selectionPopover.getBoundingClientRect().width,
          showPopover: true
        });
      }
    };

    _this.state = {
      showPopover: true,
      popoverWidth: 0,
      selectionBox: {
        top: 0,
        left: 0,
        width: 0
      }
    };
    return _this;
  }

  _createClass(SelectionPopover, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var target = document.querySelectorAll('[data-selectable]')[0];
      target.addEventListener('mouseup', this._handleMouseUp);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var target = document.querySelectorAll('[data-selectable]')[0];
      target.removeEventListener('mouseup', this._handleMouseUp);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;

      var otherProps = _objectWithoutProperties(_props, ['children', 'style']);

      var _state = this.state;
      var showPopover = _state.showPopover;
      var selectionBox = _state.selectionBox;
      var popoverWidth = _state.popoverWidth;
      var top = selectionBox.top;
      var left = selectionBox.left;
      var width = selectionBox.width;

      return _react2.default.createElement(
        'div',
        _extends({
          ref: 'selectionPopover',
          style: _extends({
            visibility: showPopover ? 'visibile' : 'hidden',
            position: 'fixed',
            top: top - 40,
            left: width / 2 - popoverWidth / 2 + left
          }, style)
        }, otherProps),
        children
      );
    }
  }]);

  return SelectionPopover;
}(_react.Component);

SelectionPopover.propTypes = {
  children: _react.PropTypes.array.isRequired,
  style: _react.PropTypes.object
};

exports.default = SelectionPopover;